#include <WiFi.h>
#include "time.h"

const char* ssid       = "SK_WiFiGIGA40F7";
const char* password   = "1712037218";

const char* ntpServer = "pool.ntp.org";
uint8_t timeZone = 9;
uint8_t summerTime = 0; // 3600

int s_hh = 12;      // 시간 설정 변수 < 0 조건 위해 자료형 int
int s_mm = 59;
uint8_t s_ss = 45;
uint16_t s_yy = 2017;
uint8_t s_MM = 11;
uint8_t s_dd = 19;

time_t now;
time_t prevEpoch;
struct tm timeinfo;

void get_NTP() {
  configTime(3600 * timeZone, 3600 * summerTime, ntpServer);
  Serial.println("NTP sync");
  while(!getLocalTime(&timeinfo)){
    Serial.println("Failed to obtain time");
    set_time();                // set time
    return;
  }
}

void set_time() {
  struct tm tm;
  tm.tm_year = s_yy - 1900;
  tm.tm_mon = s_MM - 1;
  tm.tm_mday = s_dd;
  tm.tm_hour = s_hh;
  tm.tm_min = s_mm;
  tm.tm_sec = s_ss;
  time_t t = mktime(&tm);
  printf("Setting time: %s", asctime(&tm));
  struct timeval now = { .tv_sec = t };
  settimeofday(&now, NULL);
}

void printLocalTime() {
  if (time(&now) != prevEpoch) {
    Serial.println(time(&now));
    getLocalTime(&timeinfo);
    int dd = timeinfo.tm_mday;
    int MM = timeinfo.tm_mon + 1;
    int yy = timeinfo.tm_year +1900;
    int ss = timeinfo.tm_sec;
    int mm = timeinfo.tm_min;
    int hh = timeinfo.tm_hour;
    int week = timeinfo.tm_wday;
    Serial.print(week); Serial.print(". ");
    Serial.print(yy); Serial.print(". ");
    Serial.print(MM); Serial.print(". ");
    Serial.print(dd); Serial.print(" ");
    Serial.print(hh); Serial.print(": ");
    Serial.print(mm); Serial.print(": ");
    Serial.println(ss);
    prevEpoch = time(&now);
  }
}

void setup() {
  Serial.begin(115200);
  Serial.printf("Connecting to %s ", ssid);
  WiFi.begin(ssid, password);
  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
  }
  Serial.println(" CONNECTED");
  get_NTP();
}

void loop() {
  if(Serial.available() > 0){
    String temp = Serial.readStringUntil('\n');
    if (temp == "1") set_time();   // set time
    else if (temp == "2") get_NTP(); //NTP Sync
  }
  printLocalTime();
}
